<#ibiztemplate>
TARGET=PSAPPVIEWCTRL_CHART
</#ibiztemplate>
package ${pub.getPKGCodeName()}.${de.getPSSystemModule().codeName?lower_case}.vo;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import ${pub.getPKGCodeName()}.${de.getPSSystemModule().codeName?lower_case}.domain.${de.codeName};
import lombok.Data;
import java.util.ArrayList;
import java.util.List;
import java.sql.Timestamp;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;
import com.alibaba.fastjson.JSONObject;
import java.util.Map;
import java.util.HashMap;
import org.springframework.cglib.beans.BeanMap;
import ${pub.getPKGCodeName()}.ibizutil.chart.model.ChartAxisModel;
import ${pub.getPKGCodeName()}.ibizutil.chart.model.ChartSeriesModel;
import ${pub.getPKGCodeName()}.ibizutil.chart.model.ChartModelBase;

@Data
@JsonIgnoreProperties(ignoreUnknown = true)
public class ${de.codeName}_Chart_${ctrl.codeName} extends ChartModelBase{

    /**
     * 准备图表坐标轴模型
     * @throws Exception
     */
    protected void prepareChartAxisModels() {
    <#assign index=0 >
    <#list ctrl.getPSDEChartSerieses() as Seriese>
        <#if Seriese.getXPSDEChartAxes()??>
        <#assign axesX=Seriese.getXPSDEChartAxes()>
        ChartAxisModel chartAxis${index} = new ChartAxisModel();
        chartAxis${index}.setName("${axesX.getName()}");
        chartAxis${index}.setCaption("${axesX.getCaption()}");
        chartAxis${index}.setAxisType("${axesX.getAxesType()}");
        chartAxis${index}.setAxisPos("${axesX.getAxesPos()}");
        this.registerChartAxisModel(chartAxis${index});
        <#assign index=index+1 >
        </#if>
        <#if Seriese.getYPSDEChartAxes()??>
        <#assign axesY=Seriese.getYPSDEChartAxes()>
        ChartAxisModel chartAxis${index} = new ChartAxisModel();
        chartAxis${index}.setName("${axesY.getName()}");
        chartAxis${index}.setCaption("${axesY.getCaption()}");
        chartAxis${index}.setAxisType("${axesY.getAxesType()}");
        chartAxis${index}.setAxisPos("${axesY.getAxesPos()}");
        this.registerChartAxisModel(chartAxis${index});
        <#assign index=index+1 >
        </#if>
    </#list>
    }
    /**
     * 准备图表序列模型
     * @throws Exception
     */
    protected void prepareChartSeriesModels() {
    <#assign index=0 >
    <#list ctrl.getPSDEChartSerieses() as Seriese>
        ChartSeriesModel chartSeries${index} = new ChartSeriesModel();
        chartSeries${index}.setName("${Seriese.getName()}");
        chartSeries${index}.setCaption("${Seriese.getCaption()}");
        chartSeries${index}.setSeriesType("${Seriese.getSeriesType()}");
        chartSeries${index}.setCatalogField("${Seriese.getCatalogField()?lower_case}");
        chartSeries${index}.setValueField("${Seriese.getValueField()?lower_case}");
        chartSeries${index}.setTimeGroupMode("${Seriese.getTimeGroupMode()}");
        this.registerChartSeriesModel(chartSeries${index});
        <#assign index=index+1 >
    </#list>
    }
    public Page<JSONObject> addRecordsToPage(JSONObject opt)  {
        Page<JSONObject> targetpage=new Page<JSONObject>();
        List<JSONObject> records=new ArrayList<JSONObject>();
        records.add(opt);
        targetpage.setAsc(null);
        targetpage.setDesc(null);
        targetpage.setOptimizeCountSql(false);
        targetpage.setRecords(records);
        return targetpage;
    }
    /**
    * 将entity转成map
    * @param searchResult
    * @return
    */
    public List<Map<String, Object>> pageToListDatas(Page<${de.codeName}> searchResult) {
        if(searchResult==null)
            return null;
        List<Map<String, Object>> records=new ArrayList<>();
        for(${de.codeName} source:searchResult.getRecords()) {
            ${de.codeName}_Chart_${ctrl.codeName} target=new ${de.codeName}_Chart_${ctrl.codeName}();
            records.add(target.beanToMap(source));
        }
        return records;
    }
    /**
    *将entity转成map
    * @param bean
    * @param <T>
    * @return
    */
    public <T> Map<String,Object> beanToMap(T bean){
        Map map =new HashMap<String,Object>();
        if(bean!=null){
            BeanMap beanMap=BeanMap.create(bean);
            for(Object obj:beanMap.keySet()){
                map.put(obj+"",beanMap.get(obj));
            }
        }
        return map;
    }
}